=========================================
MLVPN - Multi-Link Virtual Public Network
=========================================

author: Laurent Coustet <ed arobase zehome.com>

Take a look at the official documentation on readthedocs.org: http://mlvpn.readthedocs.org/en/latest/

Introduction
============
MLVPN a pour but de fournir un tunnel entre 2 routeurs,
en utilisant plusieurs liens, dans le but de fournir:
  * Aggrgation du dbit montant/descendant
  * Maintenir une latence faible
  * Redondance importante

Quick install
=============


Build from source
-----------------
```sh
$ ./autogen.sh
$ ./configure
$ make
$ make install
```

Build debian package
--------------------
```sh
$ dpkg-buildpackage -us -uc -rfakeroot
OR
# dpkg-buildpackage -us -uc
```

Fonctionnalits
===============
  * Aggratation de lien
  * Contrle fin de la bande passante
  * File d'mission "haute performance" sans limitation de dbit (QoS)
  * Haute-Disponibilit (supporte la perte de liens)
  * Scurit par sparation des privilges
  * Authentification du client

Fonctions non supportes
========================
MLVPN ne cherche pas a faire de la scurit au niveau des paquets qu'il traite.

Il n'y a **pas** de chiffrement, ni de compression,
ni de vrification des paquets qu'il relaye.

Il conviens donc de faire attention  la mise en place de ce systme
en mettant en place les protections indispensables au niveau du noyau
des machines htes. (iptables, pf, ...)

Principe de fonctionnement
==========================
MLVPN commence par crer deux processus, un disposant de droits root,
et l'autre des droits d'un simple utilisateur.

Une interface tuntap est ouverte pour permettre la communication entre le noyau
et l'espace utilisateur.

Ensuite, des sockets tablissent la connexion entre
le routeur A et le routeur B.

Aggrgation du dbit
--------------------
Une fois les sockets connectes, tout parquet reu sur l'interface tuntap
est relaye en Round-Robin sur chacune des sockets.

Qualit de service
------------------
Si un paquet IP dipose du champ TOS position sur 0x10, ou qu'il sagit d'un
paquet ICMP, alors MLVPN utilise une queue particulire sur chaque socket
pour une mission immdiate sans limitation de dbit.

La qualit de service ne peut tre assure que si la file d'attente au niveau
de l'oprateur reste vide ou trs peu charge.
Il conviens donc d'ajuster correctement la limitation du dbit.

Limitation de dbit
-------------------
La limitation de dbit est contrl par le fichier de configuration de MLVPN.
La limitation se fait en ajustant le temps ncessaire entre l'envoi de deux
paquets, via un calcul savant.

Ainsi on vite la file d'attente au niveau de l'oprateur, ce qui permet de
garantir une latence faible.

Authentification
----------------
Ce systme permet de grer correctement les timeout. Il n'a pas pour but
d'amliorer la scurit du systme.

Un mot de passe partag entre les 2 parties est stock dans le fichier de configuration.

Le client ne relaye les paquets qu'il reoit que si la communication a t
authentifi via ce mot de passe.

Le principe est (trop) simple:
  - client envoie un challenge alatoire
  - serveur reoit le challenge, y contatene le mot de passe
  - serveur renvoie un hash sha1 du motdepasse+challenge
  - client vrifie que le hash correspond a ce qu'il a lui mme calcul


Compatiblit
============
Linux, OpenBSD, FreeBSD (untested)

*NO* windows support.

Contributeurs au projet
=======================
Laurent Coustet, auteur et mainteneur du projet.

Philippe Pepiot, contributeur (sparation de privilges, bugfixes, ...)

Ghislain Lvque, contributeur

Fabien Dupont, bugfix!

LICENCE
=======
Voir le fichier LICENCE.

BUGS
====
Le systme de dcapsulation des paquets n'est pas fonctionnel sur la plateforme i386.

Documentation
=============
La documentation est crite au format restructuredtext.
La page de manuel est aussi crite en markdown. La conversion est ralise grace a l'outil
ronn (http://rtomayko.github.com/ronn/).
